---
title: Create API Gateway Integration
description: The POST {{apiPath}}/v1/environments/{{envID}}/gateways operation adds a new gateway resource to the specified environment resource. This sample shows how to create a gateway of type API_GATEWAY_INTEGRATION, which identifies a PingOne API Access Management gateway resource. For more information about access management, refer to PingOne Authorize API Access Management.
component: pingone-api
page_id: pingone-api:platform:gateway-management/gateways/create-api-gateway-integration
canonical_url: https://developer.pingidentity.com/pingone-api/platform/gateway-management/gateways/create-api-gateway-integration.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create API Gateway Integration

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/gateways
```

The `POST {{apiPath}}/v1/environments/{{envID}}/gateways` operation adds a new gateway resource to the specified environment resource. This sample shows how to create a gateway of type `API_GATEWAY_INTEGRATION`, which identifies a PingOne API Access Management gateway resource. For more information about access management, refer to [PingOne Authorize API Access Management](../../../authorize/api-access-management.html).

### Prerequisites

* Refer to [Gateway Management](../../gateway-management.html) for important overview information.

> **Collapse: Request Model**
>
> For property descriptions, refer to [Gateway base data model](../gateways.html#gateway-base-data-model).
>
> | Property      | Type    | Required? |
> | ------------- | ------- | --------- |
> | `description` | String  | Optional  |
> | `enabled`     | Boolean | Required  |
> | `name`        | String  | Required  |
> | `type`        | String  | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": true
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/gateways' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": true
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/gateways")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""name"": ""API-Gateway-Test""," + "\n" +
@"  ""description"": ""My API gateway""," + "\n" +
@"  ""type"": ""API_GATEWAY_INTEGRATION""," + "\n" +
@"  ""enabled"": true" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/gateways"
  method := "POST"

  payload := strings.NewReader(`{
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": true
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/gateways HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": true
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"name\": \"API-Gateway-Test\",\n  \"description\": \"My API gateway\",\n  \"type\": \"API_GATEWAY_INTEGRATION\",\n  \"enabled\": true\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/gateways")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/gateways",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "API-Gateway-Test",
    "description": "My API gateway",
    "type": "API_GATEWAY_INTEGRATION",
    "enabled": true
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/gateways',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "API-Gateway-Test",
    "description": "My API gateway",
    "type": "API_GATEWAY_INTEGRATION",
    "enabled": true
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/gateways"

payload = json.dumps({
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": True
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/gateways');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "name": "API-Gateway-Test",\n  "description": "My API gateway",\n  "type": "API_GATEWAY_INTEGRATION",\n  "enabled": true\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/gateways")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "API-Gateway-Test",
  "description": "My API gateway",
  "type": "API_GATEWAY_INTEGRATION",
  "enabled": true
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n  \"name\": \"API-Gateway-Test\",\n  \"description\": \"My API gateway\",\n  \"type\": \"API_GATEWAY_INTEGRATION\",\n  \"enabled\": true\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/gateways")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/gateways/8759fbba-d3a2-4f45-80a5-d92c87099484"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "instances": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/gateways/8759fbba-d3a2-4f45-80a5-d92c87099484/instances"
        }
    },
    "id": "8759fbba-d3a2-4f45-80a5-d92c87099484",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "API-Gateway-Test",
    "description": "My API gateway",
    "type": "API_GATEWAY_INTEGRATION",
    "enabled": true
}
```
